﻿using ASPNETCORE1.ViewModels;
using ASPNETCORE1.Services;
using Microsoft.AspNet.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ASPNETCORE1.Entities;

namespace ASPNETCORE1.Controllers
{
    public class HomeController : Controller
    {
        private IGreeter _greeter;
        private IRestauranData _restaurantData;

        public HomeController(IRestauranData restaurantData,IGreeter Greeter)
        {
            _restaurantData = restaurantData;
            _greeter = Greeter;
        }
        public ViewResult index()
        {
            var Model = new HomePageViewModel();
            Model.Restaurants = _restaurantData.GetAll();
            Model.CurrentGreeting = _greeter.GetGreeter();

            return View(Model);
        }
        //
       
        //
        [HttpPost]
        public IActionResult Edit(int id,RestaurantEditViewModel input)
        {
            var restaurant = _restaurantData.Get(id);
            //
            if(restaurant != null && ModelState.IsValid)
            {
                restaurant.Name = input.Name;
                restaurant.Cuisine = input.Cuisine;
                _restaurantData.Commit();
                return RedirectToAction("Details",new { id = restaurant.Id});
            }
            return View(restaurant);
        }

        [HttpGet]
        public IActionResult Edit(int id)
        {
            var Model = _restaurantData.Get(id);
            if (Model == null)
            {
                return RedirectToAction("Index");
            }
            return View(Model);
        }

        [HttpGet]
        public ViewResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(RestaurantEditViewModel model)
        {
            if (ModelState.IsValid)
            {
                var restaurant = new Restaurant();
                restaurant.Name = model.Name;
                restaurant.Cuisine = model.Cuisine;
                _restaurantData.Add(restaurant);
                _restaurantData.Commit();

                //return View("Details", restaurant);
                return RedirectToAction("Details", new { id = restaurant.Id });
            }
            return View();

        }

        public IActionResult Details(int id)
        {
            var Model = _restaurantData.Get(id);
            if(Model == null)
            {
                return RedirectToAction("Index");
            }
            return View(Model);
        }
    }
}
